/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ustata silikon v gurdite
    I parfuima natrapchiv i visoki botushi
    I cigari sled sexa tya obicha da pushi
*/

#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>

typedef long long llong;
const int MAXN = 500000 + 10;
const int MAXLOG = 19;
const int INF  = 1e9;

int n, q;
struct Sparse
{
    int sparse[MAXLOG][MAXN];
    int dep[MAXN];

    void build(int _par[], int _dep[])
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            sparse[0][i] = _par[i];
            dep[i] = _dep[i];
        }

        for (int lg = 1 ; (1 << lg) <= n ; ++lg)
        {
            for (int u = 1 ; u <= n ; ++u)
            {
                sparse[lg][u] = sparse[lg - 1][sparse[lg - 1][u]];
            }
        }
    }

    void equalize(int &u, int v)
    {
        for (int lg = MAXLOG - 1 ; lg >= 0 ; --lg)
        {
            if (dep[sparse[lg][u]] >= dep[v])
            {
                u = sparse[lg][u];
            }
        }
    }

    int calcLCA(int u, int v)
    {
        if (u == v)
        {
            return u;
        }

        for (int lg = MAXLOG - 1 ; lg >= 0 ; --lg)
        {
            if (sparse[lg][u] != sparse[lg][v])
            {
                u = sparse[lg][u];
                v = sparse[lg][v];
            }
        }

        return sparse[0][u];
    }

    int findLCA(int u, int v)
    {
        if (dep[u] < dep[v])
        {
            std::swap(u, v);
        }

        equalize(u, v);
        return calcLCA(u, v);
    }
};

int in[MAXN];
int out[MAXN];
int par[MAXN];
int dep[MAXN];
Sparse sparse;
int parent[MAXN];
int answer[MAXN];
std::vector <int> g[MAXN];
bool isExit[MAXN];

int timer;
void dfs(int node, int p)
{
    par[node] = p;
    dep[node] = dep[p] + 1;
    in[node] = ++timer;
    
    for (const int &u : g[node])
    {
        if (u == par[node])
        {
            continue;
        }

        dfs(u, node);
    }

    out[node] = timer;
}

int closestChild[MAXN];
int closest[MAXN];

void findClosestChild(int node)
{
    if (isExit[node])
    {
        closestChild[node] = 0;
    } else
    {
        closestChild[node] = INF;
    }

    for (const int &u : g[node])
    {
        if (u != par[node])
        {
            findClosestChild(u);
            closestChild[node] = std::min(closestChild[node], closestChild[u] + 1);
        }
    }
}

void findClosest(int node)
{
    closest[node] = closestChild[node];
    if (node != 1)
    {
        closest[node] = std::min(closest[node], closest[par[node]] + 1);
    }

    for (const int &u : g[node])
    {
        if (u != par[node])
        {
            findClosest(u);
        }
    }
}

int solveQuery(int x, int y)
{
    int ans = INF;
    int node = x;
    int lca = sparse.findLCA(x, y);
    while (node != 0)
    {
        if (dep[node] <= dep[lca])
        {
            ans = std::min(ans, dep[x] - dep[lca] + std::max(dep[lca] - dep[node] + closestChild[node], closest[y]));
        } else
        {
            ans = std::min(ans, dep[x] - dep[node] + std::max(closestChild[node], closest[y]));
        }

        node = par[node];
    }

    return ans;
}

void solve()
{
    dfs(1, 0);
    findClosestChild(1);
    findClosest(1);

    sparse.build(par, dep);
    for (int i = 1 ; i <= q ; ++i)
    {
        int x, y;
        std::cin >> x >> y;
        answer[i] = std::min(solveQuery(x, y), solveQuery(y, x));
    }
}

void print()
{
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cout << answer[i] << '\n';
    }
}

void input()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> isExit[i];
    }

    for (int i = 1 ; i < n ; ++i)
    {
        int u, v;
        std::cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}

void fastIOI()
{ 
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();
    print();

    return 0;
}