#include <iostream>
#include <vector>
#include <stack>
using namespace std;
const int MAXN=5e5+10;
bool isOut[MAXN], used[MAXN], inPath[MAXN];
int arr[MAXN], dp[MAXN], tree[4*MAXN];
vector <int> v[MAXN], path;
void fastIO() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
void find_path(int a, int b) {
    stack <int> st;
    st.push(a);
    used[a]=true;
    while (!st.empty()) {
        int x=st.top();
        if (x==b) break;
        used[x]=true;
        if (arr[x]==v[x].size()) {
            st.pop();
            continue;
        }
        while (arr[x]<v[x].size()) {
            int i=v[x][arr[x]];
            arr[x]++;
            if (!used[i]) {
                st.push(i);
                break;
            }
        }
    }
    while (!st.empty()) {
        path.push_back(st.top());
        inPath[st.top()]=true;
        st.pop();
    }
}
int find_dp(int x, int p) {
    if (isOut[x]) return dp[x]=0;
    dp[x]=MAXN;
    for (auto i:v[x]) {
        if (i==p || inPath[i]) continue;
        dp[x]=min(dp[x],find_dp(i,x)+1);
    }
    return dp[x];
}
void build_tree(int node, int l, int r) {
    if (l==r) {
        tree[node]=dp[path[l]]+path.size()-l-1;
        return;
    }
    int mid=(l+r)/2;
    build_tree(node*2,l,mid);
    build_tree(node*2+1,mid+1,r);
    tree[node]=min(tree[node*2],tree[node*2+1]);
}
int query(int node, int l, int r, int ql, int qr) {
    if (ql>r || qr<l) return MAXN;
    if (l>=ql && r<=qr) return tree[node];
    int mid=(l+r)/2;
    return min(query(node*2,l,mid,ql,qr),query(node*2+1,mid+1,r,ql,qr));
}
int find_best(int len) {
    int ans=MAXN;
    build_tree(1,0,len-1);
    int gr=len/2+len%2;
    for (int i=0;i<gr;i++) {
        int r=len-i-1;
        int s=query(1,0,len-1,i,r);
        ans=min(ans,i+max(dp[path[i]],s));
    }
    return ans;
}
void solve() {
    int ans, len=path.size();
    for (auto i:path) find_dp(i,-1);

    ans=find_best(len);
    for (int i=0;i<len/2;i++) swap(path[i],path[len-i-1]);
    ans=min(ans,find_best(len));

    cout << ans << endl;
}
int main () {
    fastIO();
    int n, q;
    cin >> n >> q;
    for (int i=1;i<=n;i++) cin >> isOut[i];
    int a, b;
    for (int i=0;i<n-1;i++) {
        cin >> a >> b;
        v[a].push_back(b);
        v[b].push_back(a);
    }
    cin >> a >> b;
    find_path(a,b);
    solve();
    return 0;
}
/*
10 1
0 1 0 1 0 1 0 1 0 0
1 2
1 3
1 4
1 5
4 6
1 7
5 8
4 9
7 10
3 10
*/
