#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 5e5 + 10;

int n, q, e[maxn];
vector < int > adj[maxn];
void input()
{
    cin >> n >> q;
    for (int i = 1; i <= n; i ++)
        cin >> e[i];
    for (int i = 1; i < n; i ++)
    {
        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
}

vector < int > path;
bool dfs(int v, int p, int target)
{
    if (v == target)
    {
        path.push_back(v);
        return true;
    }

    for (int u : adj[v])
    {
        if (u == p)
            continue;
        if (dfs(u, v, target))
        {
            path.push_back(v);
            return true;
        }
    }

    return false;
}

int dist[2][maxn];

void dist_bfs(int s, int t)
{
    for (int i = 1; i <= n; i ++)
    {
        dist[t][i] = -1;
    }

    queue < int > q;
    q.push(s);
    dist[t][s] = 0;
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int u : adj[v])
        {
            if (dist[t][u] == -1)
            {
                dist[t][u] = dist[t][v] + 1;
                q.push(u);
            }
        }
    }
}

const int inf = 1e9;
int used[maxn], cl[maxn];
int find_far(int v, int p, int t)
{
    int res = inf;
    if (e[v])
        res = min(res, dist[t][v]);
    for (int u : adj[v])
    {
        if (u == p)
            continue;
        res = min(res, find_far(u, v, t));
    }
    return res;
}

int find_cl(int v, int depth)
{
    if (e[v])
        return depth;
    int res = inf;

    used[v] = 1;
    for (int u : adj[v])
    {
        if (!used[u])
            res = min(res, find_cl(u, depth + 1));
    }
    return res;
}

void single_query(int v, int u)
{
    path.clear();
    dfs(v, -1, u);
    reverse(path.begin(), path.end());
    dist_bfs(v, 0);
    dist_bfs(u, 1);

    /**int aft_v = path[1];
    int aft_u = path[(int)(path.size()) - 2];

    int away_dist_v = find_far(v, aft_v, 0);
    int away_dist_u = find_far(u, aft_u, 1);

    int far_v = inf;
    int far_u = inf;

    for (int i = 1; i <= n; i ++)
    {
        if (e[i])
        {
            far_v = min(far_v, dist[0][i]);
                    far_u = min(far_u, dist[1][i]);
        }
    }



    //cout << "query " << away_dist_v << " " << away_dist_u << endl;
    //cout << "next " << far_v << " " << far_u << endl;
    int res = min(max(far_v, away_dist_u), max(away_dist_v, far_u));
    res = min(res, max(away_dist_v, away_dist_u));*/

    int res = inf;

    for (int i = 1; i <= n; i ++)
        used[i] = 0, cl[i] = inf;

    for (int cur : path)
    {
        used[cur] = 1;
    }

    for (int cur : path)
    {
        cl[cur] = find_cl(cur, 0);
    }

    int sz = path.size();
    for (int i = 0; i < sz; i ++)
        for (int j = 0; j < sz; j ++)
    {
        int to_i = i;
        int to_j = sz - j - 1;
        int d1 = (to_i + max(cl[path[i]], cl[path[j]] + to_j));
        int d2 = (to_j + max(cl[path[i]] + to_i, cl[path[j]]));
        res = min(res, d1);
        res = min(res, d2);
    }
    cout << res << endl;

}
void solve_queries()
{
    for (int i = 1; i <= q; i ++)
    {
        int v, u;
        cin >> v >> u;
        single_query(v, u);
    }
}
void solve()
{
    input();
    solve_queries();
}

int main()
{
    speed();
    solve();
    return 0;
}
