#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 5e5 + 10;
const int inf = 1e9;
int n, q, e[maxn];
vector < int > adj[maxn];
void input()
{
    cin >> n >> q;
    for (int i = 1; i <= n; i ++)
        cin >> e[i];
    for (int i = 1; i < n; i ++)
    {
        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
}

const int maxlog = 21;
struct jump_data
{
    int to, val_up, val_down;

    jump_data(int _to = 0, int _val_up = 0, int _val_down = 0)
    {
        to = _to;
        val_up = _val_up;
        val_down = _val_down;
    }
};

jump_data dp[maxlog][maxn];

int heavy[maxn], depth[maxn], cl_down[2][maxn], cl_up[maxn];
int sub[maxn];
void calc(int v, int p)
{
    cl_down[0][v] = cl_down[1][v] = inf;
    if (e[v])
    {
        cl_down[0][v] = 0;
    }

    heavy[v] = -1;
    for (int u : adj[v])
    {
        if (u == p)
            continue;
            depth[u] = depth[v] + 1;
        calc(u, v);
        if (cl_down[0][u] + 1 > cl_down[0][v])
        {
            cl_down[1][v] = cl_down[0][u] + 1;
        }
        else
        if (cl_down[0][u] + 1 > cl_down[1][v])
        {
            cl_down[1][v] = cl_down[0][u] + 1;
        }

        sub[v] += sub[u];
        if (heavy[v] == -1 || sub[u] > sub[heavy[v]])
            heavy[v] = u;
    }
}

jump_data unite(jump_data dw, jump_data up)
{
    jump_data res;
    res.to = up.to;
    res.val_down = min(dw.val_down, up.val_down);
    res.val_up = min(dw.val_up, up.val_up);
    return res;
}

void binary_lifting_precalc(int v, int p)
{
    if (p != -1)
    {
        int help = cl_down[0][p];
        if (cl_down[0][v] + 1 == help)
            help - cl_down[1][p];
        dp[0][v] = jump_data(p, depth[p] + cl_down[0][p], depth[p] + help);
        for (int j = 1; j < maxlog; j ++)
        {
            dp[j][v] = unite(dp[j - 1][v], dp[j - 1][dp[j - 1][v].to]);
            if (dp[j][v].to == 0)
                break;
        }
    }

    for (int u : adj[v])
    {
        if (u == p)
            continue;
        binary_lifting_precalc(u, v);
    }
}

int jump_k(int v, int k)
{
    for (int bit = 0; bit < maxlog; bit ++)
    {
        if ((k & (1 << bit)) > 0)
            v = dp[bit][v].to;
    }
    return v;
}
int get_lca(int v, int u)
{
    if (depth[v] < depth[u])
        swap(v, u);
    int k = depth[v] - depth[u];
    v = jump_k(v, k);
    if (v == u)
        return v;

    for (int bit = maxlog - 1; bit >= 0; bit --)
    {
        if (dp[bit][v].to != dp[bit][u].to)
        {
            v = dp[bit][v].to;
            u = dp[bit][u].to;
        }
    }
    return dp[0][v].to;
}

vector < int > path;
bool dfs(int v, int p, int target)
{
    if (v == target)
    {
        path.push_back(v);
        return true;
    }

    for (int u : adj[v])
    {
        if (u == p)
            continue;
        if (dfs(u, v, target))
        {
            path.push_back(v);
            return true;
        }
    }

    return false;
}



int used[maxn], cl[maxn];

int find_cl(int v, int depth)
{
    if (e[v])
        return depth;
    int res = inf;

    used[v] = 1;
    for (int u : adj[v])
    {
        if (!used[u])
            res = min(res, find_cl(u, depth + 1));
    }
    return res;
}

int single_query(int v, int u)
{

    path.clear();
    dfs(v, -1, u);
    reverse(path.begin(), path.end());



    int res = inf;

    for (int i = 1; i <= n; i ++)
        used[i] = 0, cl[i] = inf;

    for (int cur : path)
    {
        used[cur] = 1;
    }

    for (int cur : path)
    {
        cl[cur] = find_cl(cur, 0);
    }

    int sz = path.size();
    int  mp_rf = inf;
    for (int i = 0; i < sz; i ++)
    {
        mp_rf = min(mp_rf, cl[path[i]] + sz - i - 1);
    }
    for (int i = 0; i < sz; i ++)
    {
        int to_i = i;
        res = min(res, to_i + max(cl[path[i]], mp_rf));
        /**int d1 = (to_i + max(cl[path[i]], cl[path[j]] + to_j));
        int d2 = (to_j + max(cl[path[i]] + to_i, cl[path[j]]));
        res = min(res, d1);
        res = min(res, d2);*/
    }
    return res;
}
void solve_queries()
{
    for (int i = 1; i <= q; i ++)
    {
        int v, u;
        cin >> v >> u;
        int res = min(single_query(v, u), single_query(u, v));
        cout << res << endl;
    }
}
void solve()
{
    input();
    calc(1, -1);
    binary_lifting_precalc(1, -1);
    solve_queries();
}

int main()
{
    speed();
    solve();
    return 0;
}
