#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 4000000;

int n;
long long ans;
int a[MAXN + 5], pref[MAXN + 5];
pair<int, int> tree[4 * MAXN + 5];

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = {pref[l], l};
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = tree[2 * v];
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

pair<int, int> query(int v, int l, int r, int ql, int qr)
{
    if (r < ql or qr < l) return {-MAXN, 0};
    if (ql <= l and r <= qr) return tree[v];

    int mid = (l + r) / 2;
    return max(query(2 * v, l, mid, ql, qr), query(2 * v + 1, mid + 1, r, ql, qr));
}

vector<int> v1, v2;

void go(int l, int r)
{
    if (r < l) return;

    int pos = query(1, 1, n, l, r).second;

    v1.clear();
    v2.clear();
    int L, R, sz;
    if (pos - l > r - pos)
    {
        L = l - 1;
        R = pos - 1;
        sz = r - pos + 1;
        v1.resize(sz);
        for (int i = pos; i <= r; ++ i)
        {
            v1[i - pos] = pref[i];
        }
        for (int i = l - 1; i < pos; ++ i)
        {
            v2.push_back(pref[i]);
        }
    }
    else
    {
        L = pos;
        R = r;
        sz = pos - l + 1;
        v1.resize(sz);
        for (int i = l - 1; i < pos; ++ i)
        {
            v1[i - l + 1] = pref[i];
        }
        for (int i = pos; i <= r; ++ i)
        {
            v2.push_back(pref[i]);
        }
    }
    sort(v1.begin(), v1.end());

    if (n <= 20000)
    {
        for (int i = L; i <= R; ++ i)
        {
            int tmp = lower_bound(v1.begin(), v1.end(), pref[pos] - pref[i]) - v1.begin();
            ans += sz - tmp;
        }
    }

    go(l, pos - 1);
    go(pos + 1, r);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        char c;
        cin >> c;
        if (c == '(') a[i] = 1;
        else a[i] = -1;
        pref[i] = pref[i - 1] + a[i];
    }

    build(1, 1, n);

    go(1, n);

    cout << ans << endl;

    return 0;
}
