#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 4000000;

int n;
long long ans;
int a[MAXN + 5], pref[MAXN + 5];
pair<int, int> tree[4 * MAXN + 5];

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = {pref[l], l};
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = tree[2 * v];
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

pair<int, int> query(int v, int l, int r, int ql, int qr)
{
    if (r < ql or qr < l) return {-MAXN, 0};
    if (ql <= l and r <= qr) return tree[v];

    int mid = (l + r) / 2;
    return max(query(2 * v, l, mid, ql, qr), query(2 * v + 1, mid + 1, r, ql, qr));
}

vector<int> v;

vector<int> go(int l, int r)
{
    if (r < l) return {};

    int pos = query(1, 1, n, l, r).second;

    auto v1 = go(l, pos - 1);
    auto v2 = go(pos + 1, r);

    v2.push_back(pref[pos]);
    int sz1 = v1.size(), sz2 = v2.size();

    v.clear();
    int i = 0, j = 0;
    while (i < sz1 or j < sz2)
    {
        if (i == sz1)
        {
            if (pref[l - 1] + v2[j] >= pref[pos]) ans++;
            v.push_back(v2[j++]);
        }
        else if (j == sz2) v.push_back(v1[i++]);
        else if (v1[i] < v2[j]) v.push_back(v1[i++]);
        else
        {
            if (pref[l - 1] + v2[j] >= pref[pos]) ans++;
            v.push_back(v2[j++]);
        }
    }

    if (sz1 > sz2)
    {
        swap(v1, v2);
        swap(sz1, sz2);
    }

    i = 0;
    j = sz2 - 1;
    while (i < sz1 and j >= 0)
    {
        while (j >= 0 and v2[j] + v1[i] >= pref[pos]) j--;
        ans += sz2 - j - 1;
        i++;
    }
    ans += 1ll * (sz1 - i) * (sz2 - j - 1);

    return v;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        char c;
        cin >> c;
        if (c == '(') a[i] = 1;
        else a[i] = -1;
        pref[i] = pref[i - 1] + a[i];
    }

    build(1, 1, n);

    go(1, n);

    cout << ans << endl;

    return 0;
}
