#include <bits/stdc++.h>

using namespace std;

const int maxn = 5005;

int n, tt;
bool isSafe[maxn];
vector<int> g[maxn];

int dist[maxn];
bool visited[maxn];

int treeDist[maxn][maxn];

int root;

void dfsDist(int node, int par, int dep)
{
    treeDist[root][node] = dep;

    for (int i = 0; i < g[node].size(); ++i)
    {
        if (g[node][i] != par)
        {
            dfsDist(g[node][i], node, 1 + dep);
        }
    }
}

void precalc()
{
    for (int i = 1; i <= n; ++i)
    {
        root = i;
        dfsDist(root, -1, 0);
    }
}

bool state[maxn][maxn];
int ans[maxn][maxn];

void solve()
{
    int x, y;
    cin >> x >> y;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            ans[i][j] = 0;
            state[i][j] = false;
        }
    }

    queue<pair<int, int>> q;
    q.push({x, y});

    state[x][y] = true;
    ans[x][y] = 0;

    int toX, toY;

    while (!q.empty())
    {
        int nodeX = q.front().first;
        int nodeY = q.front().second;
        q.pop();

        //cout << nodeX << " " << nodeY << " :: " << ans[nodeX][nodeY] << endl;

        if (isSafe[nodeX] == true && isSafe[nodeY] == true)
        {
            cout << ans[nodeX][nodeY] << "\n";
            return;
        }

        for (int i = 0; i < g[nodeX].size(); ++i)
        {
            toX = g[nodeX][i];

            if (state[toX][nodeY] == false)
            {
                state[toX][nodeY] = true;
                ans[toX][nodeY] = 1 + ans[nodeX][nodeY];
                q.push({toX, nodeY});
            }
        }

        for (int i = 0; i < g[nodeY].size(); ++i)
        {
            toY = g[nodeY][i];

            if (state[nodeX][toY] == false)
            {
                state[nodeX][toY] = true;
                ans[nodeX][toY] = 1 + ans[nodeX][nodeY];
                q.push({nodeX, toY});
            }
        }

        for (int i = 0; i < g[nodeX].size(); ++i)
        {
            toX = g[nodeX][i];

            for (int j = 0; j < g[nodeY].size(); ++j)
            {
                toY = g[nodeY][j];

                if (state[toX][toY] == false && treeDist[toX][toY] >= treeDist[nodeX][nodeY])
                {
                    state[toX][toY] = true;
                    ans[toX][toY] = 1 + ans[nodeX][nodeY];
                    q.push({toX, toY});
                }
            }
        }
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> tt;

    for (int i = 1; i <= n; ++i)
    {
        cin >> isSafe[i];
    }

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    queue<int> q;

    for (int i = 1; i <= n; ++i)
    {
        visited[i] == false;

        if (isSafe[i] == true)
        {
            dist[i] = 0;
            q.push(i);
            visited[i] = true;
        }
    }

    while (!q.empty())
    {
        int node = q.front();
        q.pop();

        for (int i = 0; i < g[node].size(); ++i)
        {
            if (visited[g[node][i]] == false)
            {
                q.push(g[node][i]);
                visited[g[node][i]] = true;
                dist[g[node][i]] = 1 + dist[node];
            }
        }
    }

    precalc();

    while (tt--)
    {
        solve();
    }

    return 0;
}

/*
10 1
0 1 0 1 0 1 0 1 0 0
1 2
1 3
1 4
1 5
4 6
1 7
5 8
4 9
7 10
3 10
*/
