#include <bits/stdc++.h>

using namespace std;

const int maxn = 500005;
const int maxlog = 20;

int n, tt;
bool isSafe[maxn];
vector<int> g[maxn];

int jump[maxn][maxlog];
int depth[maxn];

void dfs1(int node, int par, int dep)
{
    if (par == -1)
    {
        jump[node][0] = node;
    }
    else
    {
        jump[node][0] = par;
    }

    depth[node] = dep;

    for (int i = 0; i < g[node].size(); ++i)
    {
        if (g[node][i] != par)
        {
            dfs1(g[node][i], node, dep + 1);
        }
    }
}

void precalc()
{
    dfs1(1, -1, 0);

    for (int log = 1; log < maxlog; ++log)
    {
        for (int i = 1; i <= n; ++i)
        {
            jump[i][log] = jump[jump[i][log - 1]][log - 1];
        }
    }
}

int findLCA(int x, int y)
{
    if (depth[x] < depth[y]) swap(x, y);

    int diff = depth[x] - depth[y];

    for (int i = 0; i < maxlog; ++i)
    {
        if ((diff & (1 << i)) != 0)
        {
            x = jump[x][i];
            diff -= (1 << i);
            if (diff == 0) break;
        }
    }

    if (x == y)
    {
        return x;
    }

    for (int i = maxlog - 1; i >= 0; --i)
    {
        if (jump[x][i] != jump[y][i])
        {
            x = jump[x][i];
            y = jump[y][i];
        }
    }

    return jump[x][0];
}

int dist(int x, int y)
{
    return depth[x] + depth[y] - 2 * depth[findLCA(x, y)];
}

map<pair<int, int>, bool> state;

void solve()
{
    int x, y;
    cin >> x >> y;

    queue<tuple<int, int, int>> q;
    q.push({x, y, 0});

    state[{x, y}] = true;

    int toX, toY;

    while (!q.empty())
    {
        int nodeX, nodeY, d;
        tie(nodeX, nodeY, d) = q.front();
        q.pop();

        //cout << nodeX << " " << nodeY << " :: " << ans[nodeX][nodeY] << endl;

        if (isSafe[nodeX] == true && isSafe[nodeY] == true)
        {
            cout << d << "\n";
            return;
        }

        for (int i = 0; i < g[nodeX].size(); ++i)
        {
            toX = g[nodeX][i];

            if (state.find({toX, nodeY}) == state.end())
            {
                state[{toX, nodeY}] = true;
                q.push({toX, nodeY, 1 + d});
            }
        }

        for (int i = 0; i < g[nodeY].size(); ++i)
        {
            toY = g[nodeY][i];

            if (state.find({nodeX, toY}) == state.end())
            {
                state[{nodeX, toY}] = true;
                q.push({nodeX, toY, 1 + d});
            }
        }

        for (int i = 0; i < g[nodeX].size(); ++i)
        {
            toX = g[nodeX][i];

            for (int j = 0; j < g[nodeY].size(); ++j)
            {
                toY = g[nodeY][j];

                if (state.find({toX, toY}) == state.end() && dist(toX, toY) >= dist(nodeX, nodeY))
                {
                    state[{toX, toY}] = true;
                    q.push({toX, toY, 1 + d});
                }
            }
        }
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> tt;

    for (int i = 1; i <= n; ++i)
    {
        cin >> isSafe[i];
    }

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    precalc();

    while (tt--)
    {
        solve();
    }

    return 0;
}

/*
10 1
0 1 0 1 0 1 0 1 0 0
1 2
1 3
1 4
1 5
4 6
1 7
5 8
4 9
7 10
3 10
*/
