#include <bits/stdc++.h>

using namespace std;

const int maxn = 500005;
const int inf = (1 << 30);

int n, tt;
bool isSafe[maxn];
vector<int> g[maxn];

int tim = 1;
int in[maxn];
int out[maxn];

int dist[maxn];
bool visited[maxn];

int subtreeSafe[maxn];
int subtreeClosest[maxn];

int depth[maxn];

void dfsInit(int node, int par, int dep)
{
    depth[node] = dep;
    in[node] = tim++;
    subtreeSafe[node] = isSafe[node];
    subtreeClosest[node] = (isSafe[node] == true ? 0 : inf);

    for (int i = 0; i < g[node].size(); ++i)
    {
        int to = g[node][i];

        if (to != par)
        {
            dfsInit(to, node, 1 + dep);
            subtreeClosest[node] = min(subtreeClosest[node], 1 + subtreeClosest[to]);
            subtreeSafe[node] += subtreeSafe[to];
        }
    }

    out[node] = tim - 1;
}

int root, other;

int ans = inf;

int minUp = inf;

void dfsCalc(int node, int par, int dep)
{
    //cout << node << " :: " << dep << endl;

    if (node == other)
    {
        ans = min(ans, dep + dist[other]);
        return;
    }

    //ans = min(ans, dep + dist[node] + dist[other]);
    ans = min(ans, max(dep + dist[node], subtreeClosest[other]));

    int child = -1;

    for (int i = 0; i < g[node].size(); ++i)
    {
        int to = g[node][i];

        if (to == par) continue;

        if ((in[to] <= in[other] && out[other] <= out[to]) == false)
        {
            //cout << "here for " << to << endl;

            if (subtreeSafe[to] > 0)
            {
                //cout << "now " << subtreeClosest[to] << " :: " << dist[other] << endl;
                //ans = min(ans, max(dep + subtreeClosest[to], dist[other]));
                ans = min(ans, max(dep + dist[to], subtreeClosest[other]));
                ans = min(ans, max(dep + subtreeClosest[to], subtreeClosest[other]));
            }
        }
        else
        {
            child = to;
        }
    }

    dfsCalc(child, node, dep + 1);
}

bool check()
{
    if (subtreeSafe[other] == 0)
    {
        return false;
    }

    return dist[other] == subtreeClosest[other];
}

void dfsUp(int node, int par, int d, int minDepth)
{
    if (d == 0)
    {
        if (minDepth < depth[other])
        {
            minUp = min(minUp, depth[other] - minDepth);
        }

        return;
    }

    for (int i = 0; i < g[node].size(); ++i)
    {
        if (g[node][i] != par)
        {
            dfsUp(g[node][i], node, d - 1, min(minDepth, depth[g[node][i]]));
        }
    }
}

void solve()
{
    int x, y;
    cin >> x >> y;

    root = x;
    other = y;

    tim = 1;
    dfsInit(x, -1, 0);
    ans = max(dist[root], subtreeClosest[other]);

    if (isSafe[x] == true || isSafe[y] == true || check() == true)
    {
        cout << max(dist[x], dist[y]) << "\n";
        return;
    }

    dfsUp(other, -1, dist[other], depth[other]);
    dfsCalc(x, -1, 0);

    cout << ans << "\n";
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> tt;

    for (int i = 1; i <= n; ++i)
    {
        cin >> isSafe[i];
    }

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    queue<int> q;

    for (int i = 1; i <= n; ++i)
    {
        visited[i] == false;

        if (isSafe[i] == true)
        {
            dist[i] = 0;
            q.push(i);
            visited[i] = true;
        }
    }

    while (!q.empty())
    {
        int node = q.front();
        q.pop();

        for (int i = 0; i < g[node].size(); ++i)
        {
            if (visited[g[node][i]] == false)
            {
                q.push(g[node][i]);
                visited[g[node][i]] = true;
                dist[g[node][i]] = 1 + dist[node];
            }
        }
    }

    while (tt--)
    {
        solve();
    }

    return 0;
}

/*
10 1
0 1 0 1 0 1 0 1 0 0
1 2
1 3
1 4
1 5
4 6
1 7
5 8
4 9
7 10
3 10

10 1
0 1 0 1 0 1 0 1 0 0
1 2
1 3
1 4
1 5
4 6
1 7
5 8
4 9
7 10
5 4

10 1
0 1 0 1 0 1 0 1 0 0
1 2
1 3
1 4
1 5
4 6
1 7
5 8
4 9
7 10
3 9

10 1
0 1 0 1 0 1 0 1 0 0
1 2
1 3
1 4
1 5
4 6
1 7
5 8
4 9
7 10
7 3
*/
