#include<iostream>
#include<vector>
#include<algorithm>
#include<queue>
using namespace std;
const int MAX_N=5e5+4;
const int INF=1e9;
vector<int>g[MAX_N];
int n,q;
int a,b,lca;
int ans=INF;

int dist[MAX_N][2];//0 closest/1 ban lca
bool ban[MAX_N];
int parent[MAX_N];
bool spec[MAX_N];
int used[MAX_N];
vector<int>path;

void dfs(int u,int pare)
{
    for(int v:g[u])
    {
        if(v==pare)continue;

        parent[v]=u;

        dfs(v,u);
    }
}

void makelcapath()
{
    int cur=a;
    while(cur!=0)
    {
        used[cur]++;
        cur=parent[cur];
    }
    cur=b;
    while(cur!=0)
    {
        used[cur]++;
        if(used[cur]==2){lca=cur;break;}
        cur=parent[cur];
    }

    cur=a;
    while(1)
    {
        path.push_back(cur);
        if(cur==lca)break;
        cur=parent[cur];
    }
    cur=b;
    vector<int>useless;
    while(1)
    {
        if(cur==lca)break;
        useless.push_back(cur);
        cur=parent[cur];
    }

    reverse(useless.begin(),useless.end());
    for(int x:useless)path.push_back(x);
}

void bfs(bool wh)
{
    for(int i=1;i<=n;i++)dist[i][wh]=INF;
    for(int i=1;i<=n;i++)used[i]=0;

    queue<int>q;
    for(int i=1;i<=n;i++)
    {
        if(spec[i])
        {
            dist[i][wh]=0;
            q.push(i);
            used[i]=1;
        }
    }

    while(q.size())
    {
        int u=q.front();
        q.pop();

        if(ban[u])continue;

        for(int v:g[u])
        {
            if(used[v])continue;

            used[v]=1;

            dist[v][wh]=dist[u][wh]+1;

            if(!ban[v])q.push(v);
        }
    }
}

void calc()
{
    int curdist=0;

    for(int onpath:path)
    {
        ans=min(ans,curdist+max(dist[onpath][1],0));

        curdist++;
    }

    swap(a,b);

    reverse(path.begin(),path.end());
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>q;
    for(int i=1;i<=n;i++)
    {
        cin>>spec[i];
    }
    int u,v;
    for(int i=1;i<n;i++)
    {
        cin>>u>>v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    cin>>a>>b;

    dfs(1,0);
    makelcapath();

    bfs(0);
    for(int x:path)ban[x]=1;
    bfs(1);

    calc();calc();

    cout<<ans<<"\n";

    return 0;
}
