#include<iostream>
#include<vector>
#include<algorithm>
#include<queue>
#include<tuple>
using namespace std;
const int MAX_N=1e5+4;//
const int INF=1e9;
vector<int>g[MAX_N];
int n,q;
int a,b;

int dist[MAX_N][1];//0 closest/1 ban lca
int parent[MAX_N];
bool spec[MAX_N];
int used[MAX_N];
int depth[MAX_N];


int pos[MAX_N];
int T;
int heavy[MAX_N];
int sz[MAX_N];
int close[MAX_N];
int head[MAX_N];
int nodee[MAX_N];
int dp[MAX_N];
int number[MAX_N];

vector<int>pref[MAX_N];
vector<int>suf[MAX_N];

void dfs(int u,int pare)
{
    sz[u]=1;
    dp[u]=(spec[u]==1 ? 0 : INF);
    int maxcur=0;
    for(int v:g[u])
    {
        if(v==pare)continue;

        parent[v]=u;

        depth[v]=depth[u]+1;

        dfs(v,u);

        dp[u]=min(dp[u],min(INF,dp[v]+1));

        sz[u]+=sz[v];

        if(sz[v]>maxcur)
        {
            maxcur=sz[v];
            heavy[u]=v;
        }
    }

    int cnt=0;

    for(int v:g[u])
    {
        if(v==pare)continue;

        number[v]=cnt++;

        pref[u].push_back(min(INF,dp[v]+1));
        suf[u].push_back(min(INF,dp[v]+1));
    }

    for(int i=1;i<pref[u].size();i++)
    {
        pref[u][i]=min(pref[u][i],pref[u][i-1]);
    }
    for(int i=suf[u].size()-2;i>=0;i--)
    {
        suf[u][i]=min(suf[u][i],suf[u][i+1]);
    }
}

int Ban(int x,int y)
{
    if(x==0 or number[x]==0)return dp[y];
    int curans=INF;
    int pos=number[x];
    if(pos-1>=0)curans=min(curans,pref[y][pos-1]);
    if(pos+1<suf[y].size())curans=min(curans,suf[y][pos+1]);
    return curans;
}

void decompose(int u,int h)
{
    head[u]=h;

    pos[u]=++T;
    nodee[T]=u;

    if(heavy[u])decompose(heavy[u],h);

    for(int v:g[u])
    {
        if(v==parent[u] or v==heavy[u])continue;
        decompose(v,v);
    }
}

struct V
{
    vector<pair<int,int>>dist1;
    vector<int>suf;
    vector<int>pref;
};
V tree[2*MAX_N][2];

void Init(int node,int l,int r,int wh)
{
    if(l==r)
    {
        tree[node][wh].dist1.push_back(make_pair(Ban(heavy[nodee[l]],nodee[l]),(wh==0 ? -depth[nodee[l]] : +depth[nodee[l]])));
        tree[node][wh].pref.push_back((wh==0 ? -depth[nodee[l]] : +depth[nodee[l]]));
        tree[node][wh].suf.push_back(Ban(heavy[nodee[l]],nodee[l])+(wh==0 ? -depth[nodee[l]] : +depth[nodee[l]]));
        return;
    }
    int mid=(l+r)/2;
    Init(2*node,l,mid,wh);
    Init(2*node+1,mid+1,r,wh);
    tree[node][wh].dist1=tree[2*node][wh].dist1;

    for(auto el:tree[2*node+1][wh].dist1)tree[node][wh].dist1.push_back(el);

    sort(tree[node][wh].dist1.begin(),tree[node][wh].dist1.end());

    for(int i=0;i<tree[node][wh].dist1.size();i++)
    {
        tree[node][wh].pref.push_back(tree[node][wh].dist1[i].second);
        if(i)
        {
            tree[node][wh].pref[i]=min(tree[node][wh].pref[i],tree[node][wh].pref[i-1]);
        }
    }


    int ii=0;
    for(int i=tree[node][wh].dist1.size()-1;i>=0;i--)
    {
        tree[node][wh].suf.push_back(tree[node][wh].dist1[i].first+tree[node][wh].dist1[i].second);
        if(ii)
        {
            tree[node][wh].suf[ii]=min(tree[node][wh].suf[ii],tree[node][wh].suf[ii-1]);
        }
        ii++;
    }

    reverse(tree[node][wh].suf.begin(),tree[node][wh].suf.end());
}

int Query(int node,int l,int r,int ql,int qr,int wh,int other)
{
    if(ql>qr)return INF;
    if(ql<=l && r<=qr)
    {
        int curans=INF;
        int le=0,re=tree[node][wh].dist1.size()-1;
        int firstbig=-1;
        while(le<=re)
        {
            int mid=(le+re)/2;
            if(tree[node][wh].dist1[mid].first>other)
            {
                firstbig=mid;
                re=mid-1;
            }
            else le=mid+1;
        }
        if(firstbig!=-1)curans=min(curans,tree[node][wh].suf[firstbig]);
        if(firstbig>0)curans=min(curans,tree[node][wh].pref[firstbig-1]+other);
        return curans;
    }

    int mid=(l+r)/2;

    int curans=INF;

    if(ql<=mid)curans=min(curans,Query(2*node,l,mid,ql,qr,wh,other));
    if(qr>mid)
    {
        curans=min(curans,Query(2*node+1,mid+1,r,ql,qr,wh,other));
    }

    return curans;
}

int lca(int u,int v)
{
    for(;head[u]!=head[v];v=parent[head[v]])
    {
        if(depth[head[u]]>depth[head[v]])swap(u,v);//pos[head[v]] pos[v]
    }

    if(depth[u]>depth[v])swap(u,v);//pos[u] pos[v]

    return u;
}

int query(int u,int v,int wh,int other)
{
    int curans=INF;
    int lasthead=0;

    for(;head[u]!=head[v];v=parent[head[v]])
    {
        if(depth[head[u]]>depth[head[v]])swap(u,v);//pos[head[v]] pos[v]

        curans=min(curans,Query(1,1,n,pos[head[v]],pos[v]-1,wh,other));
        curans=min(curans,Ban(lasthead,v));
        lasthead=head[v];
    }

    if(depth[u]>depth[v])swap(u,v);//pos[u] pos[v]
    curans=min(curans,Query(1,1,n,pos[u],pos[v]-1,wh,other));
    curans=min(curans,Ban(lasthead,v));
    return curans;
}

void bfs(bool wh)
{
    for(int i=1;i<=n;i++)dist[i][wh]=INF;
    for(int i=1;i<=n;i++)used[i]=0;

    queue<int>q;
    for(int i=1;i<=n;i++)
    {
        if(spec[i])
        {
            dist[i][wh]=0;
            q.push(i);
            used[i]=1;
        }
    }

    while(q.size())
    {
        int u=q.front();
        q.pop();

        for(int v:g[u])
        {
            if(used[v])continue;

            used[v]=1;

            dist[v][wh]=dist[u][wh]+1;

            q.push(v);
        }
    }
}

/*void calc()
{
    int curdist=0;

    for(int onpath:path)
    {
        ans=min(ans,curdist+max(dist[onpath][1],dist[b][0]));

        curdist++;
    }

    swap(a,b);

    reverse(path.begin(),path.end());
}*/
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>q;
    for(int i=1;i<=n;i++)
    {
        cin>>spec[i];
    }
    int u,v;
    for(int i=1;i<n;i++)
    {
        cin>>u>>v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs(1,0);
    decompose(1,1);

    bfs(0);

    Init(1,1,n,0);
    Init(1,1,n,1);

    while(q--)
    {
        cin>>a>>b;

        int ans=INF;

        int lc=lca(a,b);

        ans=min(ans,query(a,lc,0,dist[b][0])+depth[a]);
        ans=min(ans,query(b,lc,1,dist[b][0])+depth[a]-depth[lc]);
        ans=min(ans,query(b,lc,0,dist[a][0])+depth[b]);
        ans=min(ans,query(a,lc,1,dist[a][0])+depth[b]-depth[lc]);

        cout<<ans<<"\n";
    }

    return 0;
}
